%
% Script to run the segmentation procedure over a bunch of files
% and store the result as mat files.
%

imgDir  = '../BSR/bench/data/images/';
gtDir   = '../BSR/bench/data/groundTruth';

% imgDir = 'BSR/BSDS500/data/images/train';
% gtDir  = 'BSR/BSDS500/data/groundTruth/train';

% imgDir = 'BSR/BSDS500/data/images/test';
% gtDir  = 'BSR/BSDS500/data/groundTruth/test';

% imgDir = 'BSR/BSDS500/data/images/val';
% gtDir  = 'BSR/BSDS500/data/groundTruth/val';


% Output directory
outDir   = 'EvalResults/small_test';

%% Output subdirectories

edgesDir = strcat(outDir, '/edges/');
evalDir  = strcat(outDir, '/eval_dir/');

%% Loop to run over all of the image files.

iids = dir(fullfile(imgDir,'*.jpg'));
nImages = length(iids);

maxlabel_log            = zeros(nImages,1);
nccTime_log             = zeros(nImages,1);
buildW2Time_log         = zeros(nImages,1);
eigsTime_log            = zeros(nImages,1);
contours2ucmTime_log    = zeros(nImages,1);


mkdir(edgesDir);


for frame = 1:nImages
    
    % ImageFilename
    fname = fullfile(imgDir, iids(frame).name);
    
    % Call Script
    SegmentationScript;
    
    % Save the output to a file
    outFilename = fullfile(edgesDir, iids(frame).name(1:end-4));
    
    % save (outFilename, 'ucm2');
   
    imwrite (uint8(255 * (e .* max_strength)), strcat(outFilename, '.png'));

    
    maxlabel_log(frame)             = max(labels(:));
    nccTime_log(frame)              = nccTime;
    buildW2Time_log(frame)          = buildW2Time;
    eigsTime_log(frame)             = eigsTime;
    contours2ucmTime_log(frame)     = contours2ucmTime;
    
    % Progress indicator
    fprintf (1, '\n Processed %d of %d images \n', frame, nImages);
    
end

%% Run the benchmarks - note that to do this you need to install the Berkeley segmentation database and the associated code.

mkdir(evalDir);

nthresh = 49;

boundaryBench(imgDir, gtDir, edgesDir, evalDir, nthresh);

% regionBench(imgDir, gtDir, segsDir, evalDir, nthresh);

% The above two calls should be replaced by the following single call
% allBench(imgDir, gtDir, edgesDir, evalDir, nthresh);


%% Save the logs
save (fullfile(evalDir, 'Logs'), '*log');

%% Plot results

plot_eval(evalDir);
title (outDir);
